
;CodeVisionAVR C Compiler V1.25.2 Beta1 Standard
;(C) Copyright 1998-2006 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATtiny2313
;Clock frequency        : 8,000000 MHz
;Memory model           : Tiny
;Optimize for           : Speed
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 32 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: No
;Enhanced core instructions    : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATtiny2313
	#pragma AVRPART MEMORY PROG_FLASH 2048
	#pragma AVRPART MEMORY EEPROM 128
	#pragma AVRPART MEMORY INT_SRAM SIZE 128
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU WDTCR=0x21
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU SPL=0x3D
	.EQU SREG=0x3F
	.EQU GPIOR0=0x13
	.EQU GPIOR1=0x14
	.EQU GPIOR2=0x15

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x20
	.EQU __sm_mask=0x50
	.EQU __sm_powerdown=0x10
	.EQU __sm_standby=0x40

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "att.vec"
	.INCLUDE "att.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	IN   R26,MCUSR
	CBR  R26,8
	OUT  MCUSR,R26
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x80)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;GPIOR0-GPIOR2 INITIALIZATION
	LDI  R30,__GPIOR0_INIT
	OUT  GPIOR0,R30
	LDI  R30,__GPIOR1_INIT
	OUT  GPIOR1,R30
	LDI  R30,__GPIOR2_INIT
	OUT  GPIOR2,R30

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0xDF)
	OUT  SPL,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x80)
	LDI  R29,HIGH(0x80)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x80
;       1 #include <tiny2313.h>
;       2 #include <stdlib.h>
;       3 #include <delay.h>
;       4 
;       5 unsigned char opros(void)
;       6 {

	.CSEG
_opros:
;       7 while(1)//   ,  
_0x3:
;       8         {
;       9         PORTD=0xFE;//11 1111 10
	LDI  R30,LOW(254)
	OUT  0x12,R30
;      10         delay_ms(1);   
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;      11         if(PIND.2==0) return 0;
	SBIC 0x10,2
	RJMP _0x6
	LDI  R30,LOW(0)
	RET
;      12         if(PIND.3==0) return 1;
_0x6:
	SBIC 0x10,3
	RJMP _0x7
	LDI  R30,LOW(1)
	RET
;      13         if(PIND.4==0) return 2;
_0x7:
	SBIC 0x10,4
	RJMP _0x8
	LDI  R30,LOW(2)
	RET
;      14         if(PIND.5==0) return 3;
_0x8:
	SBIC 0x10,5
	RJMP _0x9
	LDI  R30,LOW(3)
	RET
;      15         PORTD=0xFD;//11 1111 01
_0x9:
	LDI  R30,LOW(253)
	OUT  0x12,R30
;      16         delay_ms(1);     
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;      17         if(PIND.2==0) return 4; 
	SBIC 0x10,2
	RJMP _0xA
	LDI  R30,LOW(4)
	RET
;      18         if(PIND.3==0) return 5;
_0xA:
	SBIC 0x10,3
	RJMP _0xB
	LDI  R30,LOW(5)
	RET
;      19         if(PIND.4==0) return 6;
_0xB:
	SBIC 0x10,4
	RJMP _0xC
	LDI  R30,LOW(6)
	RET
;      20         if(PIND.5==0) return 7;
_0xC:
	SBIC 0x10,5
	RJMP _0xD
	LDI  R30,LOW(7)
	RET
;      21         };// 
_0xD:
	RJMP _0x3
;      22 }
;      23 
;      24 void out(char alpha,unsigned char time)
;      25 {
_out:
;      26 switch(alpha)
;	alpha -> Y+1
;	time -> Y+0
	LDD  R30,Y+1
;      27         {
;      28         case 0:
	CPI  R30,0
	BRNE _0x11
;      29         PORTB=0b11000110;break;//0xC6
	LDI  R30,LOW(198)
	RJMP _0x48
;      30         case 1:
_0x11:
	CPI  R30,LOW(0x1)
	BRNE _0x12
;      31         PORTB=0b11001010;break;//0xCA
	LDI  R30,LOW(202)
	RJMP _0x48
;      32         case 2:
_0x12:
	CPI  R30,LOW(0x2)
	BRNE _0x13
;      33         PORTB=0b11010010;break;//0xD2
	LDI  R30,LOW(210)
	RJMP _0x48
;      34         case 3:
_0x13:
	CPI  R30,LOW(0x3)
	BRNE _0x14
;      35         PORTB=0b11100010;break;//0xE2 
	LDI  R30,LOW(226)
	RJMP _0x48
;      36         case 4:
_0x14:
	CPI  R30,LOW(0x4)
	BRNE _0x15
;      37         PORTB=0b11000101;break;//0xC5
	LDI  R30,LOW(197)
	RJMP _0x48
;      38         case 5:
_0x15:
	CPI  R30,LOW(0x5)
	BRNE _0x16
;      39         PORTB=0b11001001;break;//0xC9
	LDI  R30,LOW(201)
	RJMP _0x48
;      40         case 6:
_0x16:
	CPI  R30,LOW(0x6)
	BRNE _0x17
;      41         PORTB=0b11010001;break;//0xD1
	LDI  R30,LOW(209)
	RJMP _0x48
;      42         case 7:
_0x17:
	CPI  R30,LOW(0x7)
	BRNE _0x10
;      43         PORTB=0b11100001;break;//0xE1
	LDI  R30,LOW(225)
_0x48:
	OUT  0x18,R30
;      44         }
_0x10:
;      45 while(time>0)
_0x19:
	LD   R26,Y
	CPI  R26,LOW(0x1)
	BRLO _0x1B
;      46 {
;      47 delay_ms(1);
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;      48 time--;
	LD   R30,Y
	SUBI R30,LOW(1)
	ST   Y,R30
;      49 }
	RJMP _0x19
_0x1B:
;      50 PORTB=0x03;
	LDI  R30,LOW(3)
	OUT  0x18,R30
;      51 delay_ms(10);
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;      52 }
	RJMP _0x47
;      53 
;      54 void nextlevel(unsigned char level)
;      55 {
_nextlevel:
;      56 
;      57 signed char i,k; // 
;      58 
;      59 do
	RCALL __SAVELOCR2
;	level -> Y+2
;	i -> R16
;	k -> R17
_0x1D:
;      60         { 
;      61 
;      62         if(level>7) //  ,  8,     
	LDD  R26,Y+2
	CPI  R26,LOW(0x8)
	BRLO _0x1F
;      63                 k=7; 
	LDI  R17,LOW(7)
;      64         else        //        
	RJMP _0x20
_0x1F:
;      65                 {
;      66                 k=level;
	LDD  R17,Y+2
;      67                 level=0;
	LDI  R30,LOW(0)
	STD  Y+2,R30
;      68                 }
_0x20:
;      69         for (i=0;i<=k;i++)//          
	LDI  R16,LOW(0)
_0x22:
	CP   R17,R16
	BRLT _0x23
;      70                 out(i,10); 
	ST   -Y,R16
	LDI  R30,LOW(10)
	ST   -Y,R30
	RCALL _out
;      71 
;      72         if(level>=8)   //   
	SUBI R16,-1
	RJMP _0x22
_0x23:
	LDD  R26,Y+2
	CPI  R26,LOW(0x8)
	BRLO _0x24
;      73                 level-=8;
	LDD  R30,Y+2
	SUBI R30,LOW(8)
	STD  Y+2,R30
;      74 
;      75         }
_0x24:
;      76 while(level > 0);
	LDD  R26,Y+2
	CPI  R26,LOW(0x1)
	BRSH _0x1D
;      77 
;      78 }
	RCALL __LOADLOCR2
	ADIW R28,3
	RET
;      79 
;      80 void gameover(char level)
;      81 {
_gameover:
;      82 
;      83 signed char i,k,levtemp; // 
;      84 
;      85 if(level>7) //  ,  8,     
	RCALL __SAVELOCR3
;	level -> Y+3
;	i -> R16
;	k -> R17
;	levtemp -> R18
	LDD  R26,Y+3
	CPI  R26,LOW(0x8)
	BRLO _0x25
;      86 {
;      87 levtemp=level; 
	LDD  R18,Y+3
;      88 
;      89 while(levtemp>7)   //   
_0x26:
	CPI  R18,8
	BRLT _0x28
;      90 levtemp-=8;
	SUBI R18,LOW(8)
;      91 
;      92 for (i=levtemp;i>=0;i--)//          
	RJMP _0x26
_0x28:
	MOV  R16,R18
_0x2A:
	CPI  R16,0
	BRLT _0x2B
;      93     out(i,20); 
	ST   -Y,R16
	LDI  R30,LOW(20)
	ST   -Y,R30
	RCALL _out
;      94 }
	SUBI R16,1
	RJMP _0x2A
_0x2B:
;      95      
;      96 do
_0x25:
_0x2D:
;      97         { 
;      98 
;      99         if(level>7) //  ,  8,     
	LDD  R26,Y+3
	CPI  R26,LOW(0x8)
	BRLO _0x2F
;     100                 k=7; 
	LDI  R17,LOW(7)
;     101         else        //        
	RJMP _0x30
_0x2F:
;     102                 {
;     103                 k=level;
	LDD  R17,Y+3
;     104                 level=0;
	LDI  R30,LOW(0)
	STD  Y+3,R30
;     105                 }         
_0x30:
;     106         for (i=7;i>=0;i--)//          
	LDI  R16,LOW(7)
_0x32:
	CPI  R16,0
	BRLT _0x33
;     107                 out(i,20); 
	ST   -Y,R16
	LDI  R30,LOW(20)
	ST   -Y,R30
	RCALL _out
;     108        
;     109         if(level>=8)   //   
	SUBI R16,1
	RJMP _0x32
_0x33:
	LDD  R26,Y+3
	CPI  R26,LOW(0x8)
	BRLO _0x34
;     110                 level-=8;
	LDD  R30,Y+3
	SUBI R30,LOW(8)
	STD  Y+3,R30
;     111         }
_0x34:
;     112 while(level > 7);  
	LDD  R26,Y+3
	CPI  R26,LOW(0x8)
	BRSH _0x2D
;     113 }
	RCALL __LOADLOCR3
	ADIW R28,4
	RET
;     114      
;     115 void demo()
;     116 {  
_demo:
;     117 unsigned char i;
;     118 for(i=0;i<8;i++)
	ST   -Y,R16
;	i -> R16
	LDI  R16,LOW(0)
_0x36:
	CPI  R16,8
	BRSH _0x37
;     119 out(i,2);
	ST   -Y,R16
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _out
;     120 }  
	SUBI R16,-1
	RJMP _0x36
_0x37:
	LD   R16,Y+
	RET
;     121   
;     122 void main(void)
;     123 {
_main:
;     124 unsigned char level=1;
;     125 unsigned char temp=0;
;     126 unsigned char mc[25];//.  ,   
;     127 unsigned char i; 
;     128 unsigned char op;    
;     129 
;     130 // Port B initialization
;     131 // Func7=In Func6=In Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
;     132 // State7=P State6=P State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
;     133 PORTB=0xC0;
	SBIW R28,25
;	level -> R16
;	temp -> R17
;	mc -> Y+0
;	i -> R18
;	op -> R19
	LDI  R16,1
	LDI  R17,0
	LDI  R30,LOW(192)
	OUT  0x18,R30
;     134 DDRB=0x3F;
	LDI  R30,LOW(63)
	OUT  0x17,R30
;     135 
;     136 // Port D initialization
;     137 // Func6=In Func5=In Func4=In Func3=In Func2=In Func1=Out Func0=Out 
;     138 // State6=P State5=P State4=P State3=P State2=P State1=1 State0=1 
;     139 PORTD=0x7F;
	LDI  R30,LOW(127)
	OUT  0x12,R30
;     140 DDRD=0x03;
	LDI  R30,LOW(3)
	OUT  0x11,R30
;     141 
;     142 while (1)
_0x38:
;     143       { 
;     144 
;     145       while(PIND.6==1)//   S9 
_0x3B:
	SBIS 0x10,6
	RJMP _0x3D
;     146       {
;     147       temp++;//    
	SUBI R17,-1
;     148       }
	RJMP _0x3B
_0x3D:
;     149       
;     150       demo();
	RCALL _demo
;     151       delay_ms(80);
	LDI  R30,LOW(80)
	LDI  R31,HIGH(80)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     152       
;     153       {
;     154       srand((unsigned int)temp*127);//    ,     S9
	MOV  R30,R17
	LDI  R31,0
	LDI  R26,LOW(127)
	LDI  R27,HIGH(127)
	RCALL __MULW12U
	ST   -Y,R31
	ST   -Y,R30
	RCALL _srand
;     155      
;     156       for(i=0;i<level;i++)//     
	LDI  R18,LOW(0)
_0x3F:
	CP   R18,R16
	BRSH _0x40
;     157         {
;     158         mc[i]=rand()/4096;//   
	MOV  R30,R18
	MOV  R26,R28
	ADD  R30,R26
	PUSH R30
	RCALL _rand
	MOVW R26,R30
	LDI  R30,LOW(4096)
	LDI  R31,HIGH(4096)
	RCALL __DIVW21
	POP  R26
	ST   X,R30
;     159         out(mc[i],30);//    
	MOV  R26,R28
	ADD  R26,R18
	LD   R30,X
	ST   -Y,R30
	LDI  R30,LOW(30)
	ST   -Y,R30
	RCALL _out
;     160         delay_ms(20);
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     161         }
	SUBI R18,-1
	RJMP _0x3F
_0x40:
;     162            
;     163         for(i=0;i<level;i++)
	LDI  R18,LOW(0)
_0x42:
	CP   R18,R16
	BRSH _0x43
;     164         {
;     165         op=opros();//       
	RCALL _opros
	MOV  R19,R30
;     166         out(op,30);//  
	ST   -Y,R19
	LDI  R30,LOW(30)
	ST   -Y,R30
	RCALL _out
;     167         if(op!=mc[i])//       
	MOV  R26,R28
	ADD  R26,R18
	LD   R30,X
	CP   R30,R19
	BREQ _0x44
;     168           {
;     169           gameover(level);// 
	ST   -Y,R16
	RCALL _gameover
;     170           level=0;//   
	LDI  R16,LOW(0)
;     171           delay_ms(200);
	LDI  R30,LOW(200)
	LDI  R31,HIGH(200)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     172           break;
	RJMP _0x43
;     173           }
;     174         } //
_0x44:
	SUBI R18,-1
	RJMP _0x42
_0x43:
;     175         demo();// 
	RCALL _demo
;     176         delay_ms(80);
	LDI  R30,LOW(80)
	LDI  R31,HIGH(80)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     177         nextlevel(level);// 
	ST   -Y,R16
	RCALL _nextlevel
;     178         level++;//     
	SUBI R16,-1
;     179       } 
;     180       }
	RJMP _0x38
;     181 }
_0x45:
	RJMP _0x45


	.DSEG
__seed_G2:
	.BYTE 0x4

	.CSEG
_srand:
	LD   R30,Y
	LDD  R31,Y+1
	RCALL __CWD1
	STS  __seed_G2,R30
	STS  __seed_G2+1,R31
	STS  __seed_G2+2,R22
	STS  __seed_G2+3,R23
_0x47:
	ADIW R28,2
	RET
_rand:
	LDS  R30,__seed_G2
	LDS  R31,__seed_G2+1
	LDS  R22,__seed_G2+2
	LDS  R23,__seed_G2+3
	__GETD2N 0x41C64E6D
	RCALL __MULD12U
	__ADDD1N 30562
	STS  __seed_G2,R30
	STS  __seed_G2+1,R31
	STS  __seed_G2+2,R22
	STS  __seed_G2+3,R23
	mov  r30,r22
	mov  r31,r23
	andi r31,0x7F
	RET

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ANEGW1:
	COM  R30
	COM  R31
	ADIW R30,1
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__MULW12U:
	MOV  R0,R26
	MOV  R1,R27
	LDI  R24,17
	CLR  R26
	SUB  R27,R27
	RJMP __MULW12U1
__MULW12U3:
	BRCC __MULW12U2
	ADD  R26,R0
	ADC  R27,R1
__MULW12U2:
	LSR  R27
	ROR  R26
__MULW12U1:
	ROR  R31
	ROR  R30
	DEC  R24
	BRNE __MULW12U3
	RET

__MULD12U:
	PUSH R19
	PUSH R20
	PUSH R21
	LDI  R21,33
	MOV  R0,R26
	MOV  R1,R27
	MOV  R19,R24
	MOV  R20,R25
	CLR  R26
	CLR  R27
	CLR  R24
	SUB  R25,R25
	RJMP __MULD12U1
__MULD12U3:
	BRCC __MULD12U2
	ADD  R26,R0
	ADC  R27,R1
	ADC  R24,R19
	ADC  R25,R20
__MULD12U2:
	LSR  R25
	ROR  R24
	ROR  R27
	ROR  R26
__MULD12U1:
	ROR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __MULD12U3
	POP  R21
	POP  R20
	POP  R19
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
